*** samba-2.0.7/source/configure.in.2.0.7	Wed May 31 23:39:36 2000
--- samba-2.0.7/source/configure.in	Thu Jun  1 11:13:10 2000
***************
*** 1358,1363 ****
--- 1358,1381 ----
  )
  
  #################################################
+ # check for a NISPLUS_USERNAME_MAP support 
+ AC_MSG_CHECKING(whether to use NISPLUS_USERNAME_MAP)
+ AC_ARG_WITH(nisplus-username-map,
+ [  --with-nisplus-username-map     Include NISPLUS_USERNAME_MAP support
+   --without-nisplus-username-map  Don't include NISPLUS_USERNAME_MAP support (default)],
+ [ case "$withval" in
+   yes)
+     AC_MSG_RESULT(yes)
+     AC_DEFINE(WITH_NISPLUS_USERNAME_MAP)
+     ;;
+   *)
+     AC_MSG_RESULT(no)
+     ;;
+   esac ],
+   AC_MSG_RESULT(no)
+ )
+ 
+ #################################################
  # check for the secure socket layer
  AC_MSG_CHECKING(whether to use SSL)
  AC_ARG_WITH(ssl,
*** samba-2.0.7/source/acconfig.h.2.0.7	Thu Jun  1 11:57:46 2000
--- samba-2.0.7/source/acconfig.h	Thu Jun  1 11:58:18 2000
***************
*** 63,68 ****
--- 63,69 ----
  #undef WITH_NISPLUS
  #undef WITH_PAM
  #undef WITH_NISPLUS_HOME
+ #undef WITH_NISPLUS_USERNAME_MAP
  #undef WITH_AUTOMOUNT
  #undef WITH_SMBMOUNT
  #undef HAVE_BROKEN_GETGROUPS
*** samba-2.0.7/source/lib/username.c.2.0.7	Wed May 31 16:31:43 2000
--- samba-2.0.7/source/lib/username.c	Thu Jun  1 11:14:39 2000
***************
*** 22,27 ****
--- 22,53 ----
  #include "includes.h"
  extern int DEBUGLEVEL;
  
+ #ifdef WITH_NISPLUS_USERNAME_MAP
+ 
+ #ifdef BROKEN_NISPLUS_INCLUDE_FILES
+ 
+ /*
+  * The following lines are needed due to buggy include files
+  * in Solaris 2.6 which define GROUP in both /usr/include/sys/acl.h and
+  * also in /usr/include/rpcsvc/nis.h. The definitions conflict. JRA.
+  * Also GROUP_OBJ is defined as 0x4 in /usr/include/sys/acl.h and as
+  * an enum in /usr/include/rpcsvc/nis.h.
+  */
+ 
+ #if defined(GROUP)
+ #undef GROUP
+ #endif
+ 
+ #if defined(GROUP_OBJ)
+ #undef GROUP_OBJ
+ #endif
+ 
+ #endif
+ 
+ #include <rpcsvc/nis.h>
+ 
+ #endif
+ 
  /* internal functions */
  static struct passwd *uname_string_combinations(char *s, struct passwd * (*fn) (char *), int N);
  static struct passwd *uname_string_combinations2(char *s, int offset, struct passwd * (*fn) (char *), int N);
***************
*** 82,87 ****
--- 108,156 ----
      return True;
    }
    
+ #ifdef WITH_NISPLUS_USERNAME_MAP
+    if ( mapfile[0] != '/' ) {
+      nis_result* res;
+      char* unixname;
+ 
+      snprintf(buf,sizeof(buf),"[key=\"%s\"],%s",user,mapfile);
+ 
+      DEBUG(4,("Scanning NIS+ username map %s\n",mapfile));
+ 
+      res = nis_list(buf,
+ 		    FOLLOW_LINKS|FOLLOW_PATH|EXPAND_NAME,
+ 		    NULL,NULL);
+      
+      if  ( NIS_RES_STATUS(res) == NIS_SUCCESS ) {
+        unixname = ENTRY_VAL(NIS_RES_OBJECT(res),1);
+        DEBUG(3,("Mapped user %s to %s\n",user,unixname));
+        fstrcpy(last_from,user);
+        fstrcpy(user,unixname);
+        fstrcpy(last_to,user);
+        mapped_user = True;
+      } else if ( NIS_RES_STATUS(res) == NIS_NOTFOUND ) {
+        snprintf(buf,sizeof(buf),"[key=\"*\"],%s",mapfile);
+        res = nis_list(buf,
+ 		      FOLLOW_LINKS|FOLLOW_PATH|EXPAND_NAME,
+ 		      NULL,NULL);
+        if  ( NIS_RES_STATUS(res) == NIS_SUCCESS ) {
+        unixname = ENTRY_VAL(NIS_RES_OBJECT(res),1);
+        DEBUG(3,("Mapped user %s to %s\n",user,unixname));
+        fstrcpy(last_from,user);
+        fstrcpy(user,unixname);
+        fstrcpy(last_to,user);
+        mapped_user = True;
+        }
+      } else {
+        DEBUG(0,("can't search NIS+ username map %s:\n%s\n",mapfile,
+ 		nis_sperrno(NIS_RES_STATUS(res))));
+      }
+      nis_freeresult(res);
+      
+      return mapped_user;
+    }    
+ #endif
+ 
    f = sys_fopen(mapfile,"r");
    if (!f) {
      DEBUG(0,("can't open username map %s\n",mapfile));
*** /dev/null	Thu Jun  1 12:33:21 2000
--- samba-2.0.7/docs/textdocs/NISPLUS_USERNAME_MAP.txt	Thu Jun  1 11:37:31 2000
***************
*** 0 ****
--- 1,52 ----
+ !==
+ !== NISPLUS_USERMAP.txt for Samba release 2.0.7 1 June 2000
+ !==
+ Contributor:	Nicholas Brealey
+ Updated:	
+ 
+ Subject:	Using NIS+ for the username map
+ Status:		
+ ===============================================================================
+ 
+ The --with-nisplus-username-map configure option adds support for
+ NIS+ username maps.
+ 
+ 
+ To use this feature create a username map using the nistbladm command. 
+ E.g.
+ 
+ nistbladm -c key-value key=IS value= usernamemap.org_dir.your.domain.
+ 
+ Add entries with the nistbladm command.
+ E.g.
+ 
+ nistbladm -a key='"Fred Bloggs"' value=fred usernamemap.org_dir
+ nistbladm -a key='"*"' value=guest usernamemap.org_dir
+ 
+ 
+ Add the following line to the global section of the smb.conf and
+ restart samba:
+ 
+ username map =  usernamemap.org_dir.your.domain.
+ 
+ NB
+ 
+ 1) If the name of the map starts with a / it is assumed to be a standard
+    file.
+ 
+ 2) If the NIS+ lookup fails smbd does not keep trying and no mapping is
+    performed. This may be an issue if map from valid unix names to
+    other unix names.
+ 
+ 3) There is no warning about multiple matches.
+ 
+ 4) The columns in the NIS+ map are the opposite order compared to
+    the file map.
+ 
+ 
+ 
+ 
+ 
+ 
+ 
+ 
